> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cadanapay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create upload URL

> Reserve a file ID and receive a short-lived HTTPS **PUT** URL.
After the client uploads the bytes to that URL, it can reference
`fileId` in later API calls (e.g. Beneficiary creation KYC).




## OpenAPI

````yaml /openapi/embedded-payments.yaml post /v1/files/upload-url
openapi: 3.0.0
info:
  description: APIs for interacting with Cadana Global Payments
  version: 1.0.0
  title: Embedded Payments
  termsOfService: https://cadanapay.com/terms-and-conditions
  contact:
    email: api@cadanapay.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
servers:
  - url: https://api.cadanapay.com
    description: Prod Server
  - url: https://dev-api.cadanapay.com
    description: Dev Server
security:
  - Authorization: []
tags:
  - name: Beneficiaries
    description: APIs for managing beneficiaries
  - name: Payouts
    description: APIs for managing payouts
  - name: Balances
    description: APIs for managing account balances
  - name: FX
    description: APIs for managing foreign exchange rates
  - name: Resources
    description: Resource APIs to access and manage foundational data
  - name: Virtual Accounts
    description: APIs for managing virtual accounts
paths:
  /v1/files/upload-url:
    post:
      tags:
        - Beneficiaries
      summary: Create upload URL
      description: |
        Reserve a file ID and receive a short-lived HTTPS **PUT** URL.
        After the client uploads the bytes to that URL, it can reference
        `fileId` in later API calls (e.g. Beneficiary creation KYC).
      parameters:
        - $ref: '#/components/parameters/XMultiTenantKey'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UploadUrlRequest'
            examples:
              kycFront:
                summary: JPEG passport front
                value:
                  purpose: kyc-id-front
                  contentType: image/jpeg
      responses:
        '200':
          $ref: '#/components/responses/UploadUrlResponse'
        '400':
          $ref: '#/components/responses/BadRequestError'
        5XX:
          $ref: '#/components/responses/InternalError'
      security:
        - Authorization: []
components:
  parameters:
    XMultiTenantKey:
      name: X-MultiTenantKey
      in: header
      required: false
      schema:
        type: string
      description: >-
        Required when using a Platform API token. The tenant key identifying
        which business to operate on.
  schemas:
    UploadUrlRequest:
      type: object
      required:
        - purpose
        - contentType
      properties:
        purpose:
          type: string
          description: Logical reason for the upload
          enum:
            - kyc-id-front
            - kyc-id-back
            - kyc-selfie
            - kyc-id-selfie
            - kyb-incorporation-document
            - kyb-tax-certificate
            - kyb-address-proof
            - kyc-address-proof
            - reimbursements-proof
            - business-onboarding-document
            - contract
          example: kyc-id-front
        contentType:
          type: string
          description: MIME type that must be used in the PUT request
          example: image/jpeg
    BadRequestError:
      description: Bad input provided by client
      allOf:
        - $ref: '#/components/schemas/Error'
        - type: object
          properties:
            params:
              description: A map for meta data around the error that occurred
              type: object
      example:
        code: invalid_request_body
        message: The request body provided is not valid
        params:
          field: Value is invalid.
    InternalError:
      description: Internal server error
      allOf:
        - $ref: '#/components/schemas/Error'
      example:
        code: internal_error
        message: An unexpected error occurred. Please try again later.
    Error:
      type: object
      properties:
        code:
          description: A machine parsable error code
          type: string
          enum:
            - invalid_request_body
            - resource_not_found
            - forbidden
            - internal_error
        message:
          description: A human readable message describing the error
          type: string
  responses:
    UploadUrlResponse:
      description: Pre-signed PUT URL and file identifier
      content:
        application/json:
          schema:
            type: object
            required:
              - fileId
              - putUrl
              - expiresIn
            properties:
              fileId:
                type: string
                format: uuid
                example: 517075a2-17db-469f-9481-eb8347cb920c
              putUrl:
                type: string
                format: uri
                description: Pre-signed HTTPS URL (single-use)
              expiresIn:
                type: integer
                description: Seconds until the URL expires
                example: 900
          examples:
            success:
              summary: Successful reservation
              value:
                fileId: 517075a2-17db-469f-9481-eb8347cb920c
                putUrl: >-
                  https://cadana-kyc.s3.amazonaws.com/tmp/file_9c52fa2e
                  ?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=…
                expiresIn: 900
    BadRequestError:
      description: Bad input provided by client
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/BadRequestError'
    InternalError:
      description: Internal error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/InternalError'
  securitySchemes:
    Authorization:
      type: http
      scheme: bearer
      bearerFormat: API_SECRET_KEY

````